#include "fbgfx.bi" 
Using FB

const FALSE = 0
const TRUE = 1

SCREEN 18,32,2,0 ' Sets gfx screen

DIM SHARED Frame(6) AS ANY PTR ' Pointer to the memory buffer holding the sprites

Dim Shared AS Integer workpage
Dim Shared AS Double guyframe = 1 ' frame will be used to flag the current frame of Guybrush 
Dim Shared AS Double guybrush_x = -120 ' this variable will be used to flag the x position of Guybrush
Dim Shared As Double walk_by_time = 0, start_walk_time = 0 ' these two variables will be used to flag
                                                           ' the pass-by time of Guybrush
                                                           
Dim Shared As Double loop_time = 1, this_time, tb_movement_factor = 1 ' variables related to time-based movement
' loop_time -> time passed between two consecutive loops (current time - time in previous loop)
' this_time -> variable used to flag the start time of the previous loop
' tb_movement_factor -> a factor that multiplies with every movement/timing variable in the game
' if you want to sync-it with 60 FPS (make it equal 1 if the game runs 60 FPS), you multiply loop_time 
' with 60

' FPS related variables
Dim As Integer frames_per_sec = 0
Dim As Integer fps = 0
Dim As Double start_time = 0
Dim As Double timer_elapsed

start_walk_time = timer    ' Initial values of our timing variables
loop_time = timer-this_time
this_time = timer

' The code that loads our Guybrush Threepwood variables
BLOAD "frames.bmp", 0
FOR imagepos AS INTEGER = 1 TO 6
	Frame(imagepos) = IMAGECREATE (105, 157)
	GET (3+(imagepos-1)*104,0)-(103+(imagepos-1)*104,155),  Frame(imagepos)
NEXT imagepos

Do
    
    
    loop_time = timer - this_time ' calculate time between two loops
    this_time = timer ' set the current loop time
    tb_movement_factor = loop_time * 60 ' adjust movement factor to 60 FPS
                                        ' (if the program runs 60 FPS, tb_movement_factor will be 1)

    
    guyframe = guyframe + 0.09 * tb_movement_factor ' frame rotation (note how the speed of rotation is
                                                ' multiplied with tb_movement_factor)
    if guyframe > 6.5 then guyframe = 0.51 ' loop the frames (6 frames)
    
    guybrush_x = guybrush_x + 2 * tb_movement_factor ' movement formula
    if guybrush_x > 660 then 
        walk_by_time = timer - start_walk_time ' when Guybrush goes off screen
        start_walk_time = timer                ' calculate walk-by time, reset the timer,
        guybrush_x = -120                      ' set him back on the left side of the screen
    end if
    
    screenlock ' Lock our screen (nothing will be
               ' displayed until we unlock the screen).
               
    screenset workpage, workpage xor 1 ' Swap work pages.
    
   
    LINE (0,0)-(639,479), RGB(255,255,255), BF ' Color the background white
    PUT (guybrush_x ,140), Frame(guyframe), PSET ' Paste the Guybrush sprite
    
    ' Print some variables on the screen.
    LOCATE 1,1
    PRINT "FPS:"; fps
    PRINT "time-based factor:"; tb_movement_factor
    PRINT "walk-by time:"; walk_by_time
    PRINT "guyframe:"; guyframe

    workpage xor = 1 ' Swap work pages.
    screenunlock ' Unlock the page to display what has been drawn.
    
    'SLEEP 10, 1 ' Rem/unrem to test different FPS
    
    frames_per_sec += 1 ' count loops
    timer_elapsed = (timer - start_time) ' calculate when one second passes
	if timer_elapsed > 1 then 
		fps = frames_per_sec/timer_elapsed ' when one second passes calculate FPS
		frames_per_sec = 0 ' reset loop counter
	    start_time = timer ' reset start time (for 1 second formula)
	end if
    
Loop Until Multikey(FB.SC_ESCAPE)